package Praktikum01;

public class Zahlenfilter {

    public static void main(String[] args) {

        int grenze = 200;


        if (args.length > 0) {
            try {
                grenze = Integer.parseInt(args[0]);
            } catch (NumberFormatException e) {
                System.out.println("Ungültige Eingabe: '" + args[0] + "' ist keine gültige Zahl. Es wird der Standardwert 200 verwendet.");
            }
        }

        Zahlenfilter checker = new Zahlenfilter();
        checker.checkNumbers(grenze);

    }

   
    public void checkNumbers(int grenze) {
        for (int i = 1; i <= grenze; i++) {
            if (filter(i)){
                System.out.println(i);
            }
        }
    }
    public boolean filter(int i){
        return !(checkDivideByFive(i) || checkEndsWithNine(i) || checkSumWithPrev(i)) ;
    }
    
    private Boolean checkDivideByFive(int i) {
        return i % 5 == 0;
    }


    private Boolean checkEndsWithNine(int i) {
        return i % 10 == 9;
    }


    private Boolean checkSumWithPrev(int i) {
        if (i > 1) {
            int vorgaenger = i - 1;
            int summe = i + vorgaenger;
            return summe % 3 == 0;
        }
        return false;
    }

}
